//
//  $Id: BinaryTreeNode.m,v 1.2 2007/04/02 03:14:43 rh Exp $
//  A private binary tree node class
//
//  Created by René Hexel on 2/04/07.
//  Copyright 2007 Rene Hexel. All rights reserved.
//

#import "BinaryTreeNode.h"

/*
 * implementation of the binary tree node class
 */
@implementation _BinaryTreeNode

- parentNode	{ return parent; }
- leftChild	{ return left; }
- rightChild	{ return right; }
- object	{ return object; }


- setParentNode: (_BinaryTreeNode *) newParent
{
	id old = parent;
	parent = [newParent retain];
	
	return [old autorelease];
}


- setLeftChild: (_BinaryTreeNode *) newLeft
{
	id old = left;
	left = [newLeft retain];
	
	return [old autorelease];
}


- setRightChild: (_BinaryTreeNode *) newRight
{
	id old = right;
	right = [newRight retain];
	
	return [old autorelease];
}


- setObject: (id) newObj
{
	[newObj retain];
	[object release];
	object = newObj;
	
	return self;
}


- (void) dealloc
{
	[object release];
	[parent release];
	[left release];
	[right release];
	
	[super dealloc];
}


- (unsigned) count
{
	return [left count] + [right count] + 1;
}


+ treeWithEnumerator: (NSEnumerator *) e count: (int) n
{
	if (n <= 0) return nil;

	_BinaryTreeNode *node = [_BinaryTreeNode new];

	[node setLeftChild:	[_BinaryTreeNode treeWithEnumerator: e
							      count: n/2]];
	[node setObject:	[e nextObject]];
	[node setRightChild:	[_BinaryTreeNode treeWithEnumerator: e
							      count: (n-1)/2]];
	return [node autorelease];
}


@end


