/*
 * $Id: Main.m,v 1.3 2007/04/02 04:56:05 rh Exp $
 * A simple test program for SimpleTree and BinaryTree
 */
#import <Foundation/Foundation.h>
#import "BinaryTree.h"

#include <stdlib.h>
#include <stdio.h>

int main (int argc, const char *argv[])
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	BinaryTree *tree;

	printf("Simplified BinaryTree test starting.\n");

	NSProcessInfo *pi = [NSProcessInfo processInfo];
	NSArray *args = [pi arguments];
	NSEnumerator *e = [args objectEnumerator];
	[e nextObject];		// skip first parameter
    
	if ([args count] > 1)
		tree = [[BinaryTree alloc] initWithEnumerator: e
							count: [args count]-1];
	else
		tree = [[BinaryTree alloc] initWithObjects:
			@"2", @"*", @"3", @"-", @"4", @"/", @"7", nil];

	printf("Binary tree %p allocated with %d nodes:\n", tree, [tree count]);

	printf("Infix:   ");    
	e = [tree inorderEnumerator];
	id obj;
	while ((obj = [e nextObject]) != nil)
		printf(" %s ", [[obj description] cString]);

	printf("\nPrefix:  ");
	e = [tree preorderEnumerator];
	while ((obj = [e nextObject]) != nil)
		printf(" %s ", [[obj description] cString]);
	
	printf("\nPostfix: ");
	e = [tree postorderEnumerator];
	while ((obj = [e nextObject]) != nil)
		printf(" %s ", [[obj description] cString]);
	
	printf("\nBreadth: ");
	e = [tree breadthFirstEnumerator];
	while ((obj = [e nextObject]) != nil)
		printf(" %s ", [[obj description] cString]);
	printf("\n");

	[tree release];
	[pool release];

	return EXIT_SUCCESS;
}
