//
//  $Id: SimpleQueue.h,v 1.1 2007/04/02 04:56:05 rh Exp $
//  A Example queue class interface using NSMutableArray
//
//  Created by Rene Hexel on 29/03/07.
//  Copyright 2007 Rene Hexel. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 * A simple queue class using NSMutableArray
 */
@interface SimpleQueue: NSObject
{
	NSMutableArray *elements;	/** elements held by the queue */
}

/**
 * default queue initialiser
 */
- init;

/**
 * release references and deallocate memory
 */
- (void) dealloc;

/**
 * push an object onto the end of the queue
 */
- pushObject: object;

/**
 * pop an object off the beginning of the queue
 */
- popObject;

/**
 * return the element at the beginning of the queue without removing it
 */
- peekObject;

/**
 * swap the two elements at the beginning of the queue
 */
- swapTopMostObjects;

/**
 * return YES if the queue is empty
 */
- (BOOL) isEmpty;

@end
