//
//  $Id: SimpleQueue.m,v 1.1 2007/04/02 04:56:05 rh Exp $
//  A Example queue class implementation using NSMutableArray
//
//  Created by Rene Hexel on 29/03/07.
//  Copyright 2007 Rene Hexel. All rights reserved.
//

#import "SimpleQueue.h"

@implementation SimpleQueue

- init
{
	if (!(self = [super init]))
		return nil;
	
	if (!(elements = [NSMutableArray new]))
	{
		[self release];
		return nil;
	}
	
	return self;
}


- (void) dealloc
{
	[elements release];
	[super dealloc];
}


- pushObject: object
{
	[elements addObject: object];
	
	return self;
}


- popObject
{
	id object = [[self peekObject] retain];

	[elements removeObjectAtIndex: 0];
	
	return [object autorelease];
}


- peekObject
{
	return [elements objectAtIndex: 0];
}


- swapTopMostObjects
{
	[elements exchangeObjectAtIndex: 0 withObjectAtIndex: 1];

	return self;
}


- (BOOL) isEmpty
{
	return [elements count] == 0;
}


@end
