//
//  $Id: SimpleStack.h,v 1.2 2007/04/02 03:14:43 rh Exp $
//  A Example stack class interface using NSMutableArray
//
//  Created by Rene Hexel on 29/03/07.
//  Copyright 2007 Rene Hexel. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 * A simple stack class using NSMutableArray
 */
@interface SimpleStack: NSObject
{
	NSMutableArray *elements;	/** elements held by the stack */
}

/**
 * default stack initialiser
 */
- init;

/**
 * release references and deallocate memory
 */
- (void) dealloc;

/**
 * push an object onto the stack
 */
- pushObject: object;

/**
 * pop an object off the stack
 */
- popObject;

/**
 * return the element at the top of the stack without removing it
 */
- peekObject;

/**
 * swap the two elements at the top of the stack
 */
- swapTopMostObjects;

/**
 * return YES if the stack is empty
 */
- (BOOL) isEmpty;

@end
