//
//  $Id: SimpleStack.m,v 1.2 2007/04/02 03:14:43 rh Exp $
//  A Example stack class implementation using NSMutableArray
//
//  Created by Rene Hexel on 29/03/07.
//  Copyright 2007 Rene Hexel. All rights reserved.
//

#import "SimpleStack.h"

@implementation SimpleStack

- init
{
	if (!(self = [super init]))
		return nil;
	
	if (!(elements = [NSMutableArray new]))
	{
		[self release];
		return nil;
	}
	
	return self;
}


- (void) dealloc
{
	[elements release];
	[super dealloc];
}


- pushObject: object
{
	[elements addObject: object];
	
	return self;
}


- popObject
{
	id object = [[self peekObject] retain];

	[elements removeObjectAtIndex: [elements count] - 1];
	
	return [object autorelease];
}


- peekObject
{
	return [elements objectAtIndex: [elements count] - 1];
}


- swapTopMostObjects
{
	unsigned n = [elements count];
	
	[elements exchangeObjectAtIndex: n-1 withObjectAtIndex: n-2];
	
	return self;
}


- (BOOL) isEmpty
{
	return [elements count] == 0;
}


@end
